/*

  yyycpu - a virtual machine
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __MEMBUNCH_HPP
#define __MEMBUNCH_HPP

#include "binarydefs.hpp"

// i work in normal byteorder, not intel !!!
class membunch {
public:
  membunch (const membunch &);
  membunch & operator= (const membunch &);
  membunch (uint8 *const memory_, const uint32 memsize_); // the memory is not deleted by membunch.

  // if illegal accesses are done, a warning goes to stdout.
  // if get does illegal access, 0 is returned
  // if set does illegal access, nothing is changed.
  uint8 get8(const uint32 addr) const;
  void set8(const uint32 addr, const uint8 value);
  uint16 get16(const uint32 addr) const;
  void set16(const uint32 addr, const uint16 value);
  uint32 get32(const uint32 addr) const;
  void set32(const uint32 addr, const uint32 value);

  uint8 *memory;
  uint32 memsize;
};

#endif
