/*

  yyycpu - a virtual machine
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __CODEMANAGER_HPP
#define __CODEMANAGER_HPP

#include "../common/binarydefs.hpp"

#include <stdio.h>
#include <vector>

class codemanager {
public:
  codemanager ();
  codemanager (const codemanager &);
  codemanager & operator= (const codemanager &);
  ~codemanager ();

  const uint8 get8(const uint32 address);
  void put8(const uint32 address, const uint8 value);
  const uint16 get16(const uint32 address);
  void put16(const uint32 address, const uint16 value);
  void put32(const uint32 address, const uint32 value);
  void writeout(FILE *const output) const;
  uint32 len() const;
  void cut (const uint32 address, const uint32 count);

private:
  vector <uint8> code;
};

#endif
