/*

  yyycpu - a virtual machine
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "strglist.hpp"

#include "../common/binarydefs.hpp"

#include <stdio.h>

strglist::strglist()
{
};

strglist::~strglist()
{
};

strglist::index_t strglist::add_interpreted (const string &strg)
{
  vec.push_back(elem(""));
  index_t index=vec.size()-1;
  string &s=vec[index].strg;
  for (unsigned i=0;i<strg.size();i++) {
    uint8 c=strg[i];
    if ((c>=32)&&(c<=127)) {
      if (c=='\\') {
	i++;
	if (i==strg.size()) throw "strglist::add_interpreted: string mustn't end with a \\";
	c=strg[i];
	switch (c) {
	case 'n': s+=0xa; break;
	default:
	  throw "strglist::add_interpreted: unknown \\ sequence";
	};
      }else{
	s+=c;
      };
    }else{
      throw "strglist::add_interpreted: illegal characters in string.";
    };
  };
  return index;
};

void strglist::debugprint ()
{
  printf("STRGLIST DEBUG\n");
  for (index_t i=0;i<vec.size();i++) {
    printf("INDEX=%d STRG=\"%s\"\n", i, vec[i].strg.c_str());
  };
};
