/*

  yyycpu - a virtual machine
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __SYMBOLLIST_HPP
#define __SYMBOLLIST_HPP

#include <string>
#include <vector>

class symbollist {
public:
  struct elem {
    inline elem(const string &symbol_)
      : symbol(symbol_) {};
    string symbol;
  };

  typedef vector<elem>::size_type index_t;


  symbollist ();
  symbollist (const symbollist &);
  symbollist & operator= (const symbollist &);
  ~symbollist ();

  //  index_t add (const string &symbol);
  //  index_t find (const string &symbol);
  index_t findoradd (const string &symbol);
  inline elem & get (const index_t symbolindex) { return vec[symbolindex]; };

  void debugprint ();

private:
  vector<elem> vec;
};

#endif
