/*

  yyycpu - a virtual machine
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __MACHCORE_H
#define __MACHCORE_H

#include <sys/types.h>

#ifdef __cplusplus
extern "C" {
#endif

  void machcore_initialize(const u_int32_t memsize_);
  void machcore_reset(); /* does not clear memory */
  void machcore_deinitialize();
  void machcore_execute(int count);

  /* you must define those functions */
  extern void machcore_illegalinstruction();
  extern void machcore_illegalmemoryaccess();
  extern u_int32_t machcore_in(const u_int32_t port);
  extern void machcore_out(const u_int32_t port, const u_int32_t value);

  /* the machine representation */
  extern u_int32_t machcore_memsize;
  extern u_int8_t *machcore_memory;
  extern u_int32_t machcore_PC;
  extern u_int32_t machcore_regs[16];
  extern int machcore_interrupt_enable;

#ifdef __cplusplus
};
#endif

#endif

